Attribute VB_Name = "Sample"
'====================================================================
' Apci8284s.bas
'--------------------------------------------------------------------
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'====================================================================
Option Explicit

Public Const WM_USERMES = &H600
Public Const WM_APCI8284 = WM_USERMES + 100
Public Const GWL_WNDPROC = -4
Public Const DMA_BUFSIZE = &HFFF
Public Const LOCALADR = &H10000
Public Const INTCSR = &H68
Public Const DMAMODE0 = &H80
Public Const DMAPADR0 = &H84
Public Const DMALADR0 = &H88
Public Const DMASIZ0 = &H8C
Public Const DMADPR0 = &H90
Public Const DMACSR0 = &HA8

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Global lpPrevWndProc As Long
Global gHW As Long
Global DmaBuf() As Byte
Global wLogSlot As Integer

'====================================================================
' `DMA ]Jn
'====================================================================
Public Sub OnLoad()
    Dim strbuf As String
    Dim Res As APCI8284RESOURCE
    Dim i As Integer
    Dim PhysAddr As Long

    '----------------------------------------------------------------
    ' Apci8284.DLL J
    '----------------------------------------------------------------
    If Apci8284wDllOpen() = False Then
        ErrorMessage (APCI8284_SLOT_AUTO)
        Exit Sub
    End If
    ResultMessage ("Apci8284.dll J܂")
    '----------------------------------------------------------------
    ' foCX̎gp錾
    '----------------------------------------------------------------
    wLogSlot = APCI8284_SLOT_AUTO
    If Apci8284wCreate(wLogSlot, gHW, WM_APCI8284) = False Then
        ErrorMessage (APCI8284_SLOT_AUTO)
        Exit Sub
    End If
    strbuf = "foCX̎gp錾" + Chr(10) + _
    "LogSlot = " + Str(wLogSlot)
    ResultMessage (strbuf)
    '----------------------------------------------------------------
    ' \[X\
    '----------------------------------------------------------------
    If Apci8284wGetResource(wLogSlot, Res) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "\[X擾" + Chr(10) + _
    "I/O ̈搔F" + Str(Res.dwNumIoRegion) + Chr(10)
    For i = 1 To Res.dwNumIoRegion
        strbuf = strbuf + _
        "I/O Address " + Str(i) + "=" + _
        Hex(Res.dwIoBase(i)) + " - " + _
        Hex(Res.dwIoBase(i) + Res.dwIoLength(i) - 1) + Chr(10)
    Next i

    strbuf = strbuf + _
    "MEM ̈搔F" + Str(Res.dwNumMemRegion) + Chr(10)
    For i = 1 To Res.dwNumMemRegion
        strbuf = strbuf + _
        "MEM Address " + Str(i) + "=" + _
        Hex(Res.dwMemBase(i)) + " - " + _
        Hex(Res.dwMemBase(i) + Res.dwMemLength(i) - 1) + Chr(10)
    Next i

    strbuf = strbuf + _
    "IRQF" + Str(Res.dwIrq) + Chr(10)
    ResultMessage (strbuf)
    '----------------------------------------------------------------
    ' DMA ]pobt@̊m
    '----------------------------------------------------------------
    If Apci8284wDmaAlloc(wLogSlot, DMA_BUFSIZE, PhysAddr) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "DMA ]pobt@mۂ܂" + Chr(10) + _
    "AhX = " + Hex(PhysAddr) + Chr(10) + _
    "TCY = " + Hex(DMA_BUFSIZE)
    ResultMessage (strbuf)
    '----------------------------------------------------------------
    ' DMA ]pobt@[NA
    '----------------------------------------------------------------
    ReDim DmaBuf(0 To DMA_BUFSIZE)
    If Apci8284wDmaWrite(wLogSlot, 0, DmaBuf, DMA_BUFSIZE) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '----------------------------------------------------------------
    ' DMA ]pobt@ǂݍ
    '----------------------------------------------------------------
    If Apci8284wDmaRead(wLogSlot, 0, DmaBuf, DMA_BUFSIZE) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    DmaView
    ResultMessage ("DMA ]Jn܂")
    '-----------------------------------------------------------------
    ' INTCSR(Interrupt Control/Status Register) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteDWord(wLogSlot, 0, INTCSR, &H40100) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' DMAMODE0(DMA Channel 0 Mode Register) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteDWord(wLogSlot, 0, DMAMODE0, &H20441) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' DMAPADR0(DMA Channel 0 PCI Address Register ) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteDWord(wLogSlot, 0, DMAPADR0, PhysAddr) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' DMALADR0(DMA Channel 0 Local Address Register ) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteDWord(wLogSlot, 0, DMALADR0, LOCALADR) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' DMASIZ0(DMA Channel 0 Transfer Size Register ) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteDWord(wLogSlot, 0, DMASIZ0, DMA_BUFSIZE) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' DMADPR0(DMA Channel 0 Descriptor Pointer Register ) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteByte(wLogSlot, 0, DMADPR0, &H8) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' DMACSR0(DMA Channel 0 Command/Status Register ) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteByte(wLogSlot, 0, DMACSR0, &H3) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

End Sub
'====================================================================
' I
'====================================================================
Public Sub OnUnLoad()
    Dim strbuf As String

    '----------------------------------------------------------------
    ' DMA ]pobt@J
    '----------------------------------------------------------------
    If Apci8284wDmaFree(wLogSlot) = True Then
        ResultMessage ("DMA ]pobt@J܂")
    End If
    '----------------------------------------------------------------
    ' foCXJ
    '----------------------------------------------------------------
    If Apci8284wClose(wLogSlot) = True Then
        strbuf = "foCX " + Str(wLogSlot) + "J܂"
        ResultMessage (strbuf)
    End If
    '----------------------------------------------------------------
    ' Apci8284.DLL 
    '----------------------------------------------------------------
    If Apci8284wDllClose() = True Then
        ResultMessage ("Apci8284.dll ܂")
    End If
End Sub
'====================================================================
' TuNXs
'====================================================================
Public Sub Hook()
    lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub
'====================================================================
' TuNX
'====================================================================
Public Sub Unhook()
    Dim temp As Long
    temp = SetWindowLong(gHW, GWL_WNDPROC, lpPrevWndProc)
End Sub
'--------------------------------------------------------------------
' EBhEbZ[W
'--------------------------------------------------------------------
Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim strbuf As String
    
    If uMsg = WM_APCI8284 Then
        ResultMessage ("DMA ]܂(DEVICE  PC)")
        OnIrq (CInt(wParam))
        Exit Function
    End If
    
    WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function
'--------------------------------------------------------------------
' aPCI-8284 荞ݏ
'--------------------------------------------------------------------
Function OnIrq(ByVal slot As Integer)

    '-----------------------------------------------------------------
    ' DMACSR0(DMA Channel 0 Command/Status Register ) ݒ
    '-----------------------------------------------------------------
    If Apci8284wMemWriteByte(slot, 0, DMACSR0, &H80) = False Then
        Exit Function
    End If
    '-----------------------------------------------------------------
    ' DMA ]pobt@ǂݍ
    '-----------------------------------------------------------------
    If Apci8284wDmaRead(slot, 0, DmaBuf, DMA_BUFSIZE) = False Then
        Exit Function
    End If
    DmaView
End Function
'====================================================================
' DMA ]pobt@̃ANZXpobt@̐擪oCg\
'====================================================================
Public Sub DmaView()

    Dim strbuf As String
    Dim i, j, cnt As Integer

    cnt = 0
    strbuf = "DMA ]pobt@ǂݍ݂܂" + Chr(10)
    For i = 0 To &HF
        For j = 0 To &HF
            strbuf = strbuf + Hex(DmaBuf(cnt)) + " "
            cnt = cnt + 1
        Next j
        strbuf = strbuf + Chr(10)
    Next i
    MsgBox strbuf, vbOKOnly + vbInformation
End Sub
'====================================================================
' ʂ\
'====================================================================
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub
'====================================================================
' G[bZ[W\
'====================================================================
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Apci8284wGetLastError(wLogSlot)

    Select Case dwRes
    Case APCI8284_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aPCI-8284 error" + Chr(10) + Chr(10) + _
                "Error code: " + _
                Str(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical


End Sub

